#
# spec file for package perf
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#



Name:           perf
%define version %(rpm -q --qf '%{VERSION}' kernel-source)
Version:        %version
Release:        2.10.1
License:        GPL v2 only
Summary:        Performance Counters For Linux
Group:          Development/Tools/Debuggers
BuildRequires:  asciidoc
BuildRequires:  binutils-devel
BuildRequires:  kernel-source >= 2.6.31
BuildRequires:  libdw-devel
BuildRequires:  libelf-devel
BuildRequires:  newt-devel
BuildRequires:  openssl-devel
BuildRequires:  xmlto
BuildRequires:  zlib-devel
BuildRequires:  flex
BuildRequires:  bison
Requires:       kernel >= 2.6.31
AutoReqProv:    on
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
# not supported in kernel
ExcludeArch:    ia64

Patch1:         bnc806964-perf-tools-add-missing-node-alias-to-the-hw_cache-array.patch
Patch2:         bnc806964-perf-tools-de-opt-the-parse_events-function.patch
Patch3:         bnc806964-perf-tools-add-automated-tests-for-events-parsing.patch
Patch4:         bnc806964-perf-tools-make-test-use-the-preset-debugfs-path.patch
Patch5:         bnc806964-perf-list-fix-exit-value.patch
Patch6:         bnc806964-perf-tools-fix-error-handling-of-unknown-events.patch
Patch7:         bnc806964-perf-tools-add-support-for-disabling-error-via-werror0.patch
Patch8:         bnc806964-perf-tools-eliminate-duplicate-code-and-use-path_max-consistently.patch
Patch9:         bnc806964-perf-tools-simplify-debugfs-mountpoint-handling-code.patch
Patch10:        bnc806964-perf-evlist-introduce-perf_evlist__add_attrs.patch
Patch11:        bnc806964-perf-test-add-more-automated-tests-for-event-parsing.patch
Patch12:        bnc806964-perf-add-support-for-perf_hw_count_ref_cpu_cycles.patch
Patch13:        bnc806964-perf-tools-add-x86-rdpmc-rdtsc-test.patch
Patch14:        bnc806964-perf-kvm-do-guest-only-counting-by-default.patch
Patch15:        bnc806964-perf-evlist-make-splice_list_tail-method-public.patch
Patch16:        bnc806964-perf-tools-add-sysfs-mountpoint-interface.patch
Patch17:        bnc806964-perf-tools-add-bitmap_or-function-into-bitmap-object.patch
Patch18:        bnc806964-perf-record-fix-buffer-overrun-bug-in-tracepoint_id_to_path.patch
Patch19:        bnc806964-perf-tools-add-parser-generator-for-events-parsing.patch
Patch20:        bnc806964-perf-tools-add-config-options-support-for-event-parsing.patch
Patch21:        bnc806964-perf-tools-add-perf-pmu-object-to-access-pmu-format-definition.patch
Patch22:        bnc806964-perf-tools-add-support-to-specify-pmu-style-event.patch
Patch23:        bnc806964-perf-tools-fix-various-casting-issues-for-32-bits.patch
Patch24:        bnc806964-perf-tools-fix-modifier-to-be-applied-on-correct-events.patch
Patch25:        bnc806964-perf-tools-add-missing-ref-cycles-event-back-to-event-parser.patch
Patch26:        bnc806964-perf-tools-remove-auto-generated-bison-flex-files.patch
Patch27:        bnc806964-perf-tools-fix-parsers-rules-to-dependencies.patch
Patch28:        bnc806964-perf-tools-fix-include-header-files-in-util-parse-events.h.patch
Patch29:        bnc806964-perf-turn-off-compiler-warnings-for-flex-and-bison-generated-files.patch
Patch30:        bnc806964-perf-tools-split-term-type-into-value-type-and-term-type.patch
Patch31:        bnc806964-perf-test-move-parse-event-automated-tests-to-separated-object.patch
Patch32:        bnc806964-perf-tools-add-support-for-displaying-event-parser-debug-info.patch
Patch33:        bnc806964-perf-tools-use-allocated-list-for-each-parsed-event.patch
Patch34:        bnc806964-perf-tools-separate-mem-event-scanner-bits.patch
Patch35:        bnc806964-perf-tools-add-hardcoded-name-term-for-pmu-events.patch
Patch36:        bnc806964-perf-tool-use-data-struct-for-arg-passing-in-event-parse-function.patch
Patch37:        bnc806964-perf-tool-make-the-event-parser-re-entrant.patch
Patch38:        bnc806964-perf-tool-add-support-to-reuse-event-grammar-to-parse-out-terms.patch
Patch39:        bnc806964-perf-tool-add-pmu-event-alias-support.patch
Patch40:        bnc806964-perf-tools-fix-build-with-older-versions-of-bison.patch
Patch41:        bnc806964-adjust-tracepoint-parsing-tests.patch
Patch42:        bnc811986-perf-annotate-fix-off-by-one-symbol-hist-size-allocation-and-hit-accounting.patch
Patch43:        bnc811986-perf-symbols-introduce-symbol__size-method.patch
Patch44:        bnc811986-perf-annotate-prevent-overflow-in-size-calculation.patch


%description
This package provides a tool 'perf', which monitors performance for
either unmodified binaries or the entire system. It requires a Linux
kernel which includes the performance counters subsystem (kernel
version >= 2.6.31).



Authors:
--------
    Ingo Molnar

%prep
# copy necessary files from kernel-source since we need to modify them
(cd /usr/src/linux ; tar -cf - COPYING CREDITS README tools include scripts Kbuild Makefile arch/*/{include,lib,Makefile} lib) | tar -xf -
chmod +x tools/perf/util/generate-cmdlist.sh

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1

%build
cd tools/perf
make V=1 CFLAGS="%{optflags}" ASCIIDOC8=1 all doc prefix=/usr perfexecdir=%{_libexecdir}/%{name}

%install
cd tools/perf
make CFLAGS="%{optflags}" install install-doc prefix=/usr perfexecdir=%{_libexecdir}/%{name} DESTDIR=%{buildroot}

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root)
%doc COPYING CREDITS README tools/perf/design.txt
%{_bindir}/perf
%{_libexecdir}/%{name}
%{_mandir}/man1/perf*

%changelog
* Wed Mar 27 2013 tonyj@suse.com
- Fix powerpc perf report segfault when using --tui (bnc#811986)
- Fix missing Patch-mainline flags from previous checkin
- Remove duplicate BuildRequires: kernel-source
* Sat Mar 23 2013 tonyj@suse.com
- Add uncore support (bnc#806964)
- Fix perf version (bnc#808287)
* Wed Jun 15 2011 tonyj@novell.com
- Update spec file for initial SP2 checkin
* Tue May  4 2010 ro@suse.de
- excludearch for ia64, never built
* Wed Mar 31 2010 tonyj@novell.com
- Fix sparse CPU numbering (bnc#592116)
- Dynamically allocate arrays based on #configured cpus (bnc#585238)
* Fri Oct 16 2009 tonyj@suse.de
- Initial checkin for SLE11SP1 (FATE: #303968/#304106)
- Update for new options (sched, timechart, trace)
* Wed Aug 26 2009 aj@suse.de
- Remove libbfd.patch since it does not apply and use
  SUSE_ASNEEDED=0 instead.
- Set flag for asciidoc version 8.
* Sun Aug  2 2009 tonyj@suse.de
- Initial checkin of Performance Counters for Linux (PCL) userspace.
  This builds tools/perf out of kernel-source package and requires
  kernel >= 2.6.31
